subroutine calcenergy(Pos, L, Cut, ratio, PEnergy, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(out) :: PEnergy
    real(8), intent(in) :: L, Cut, ratio
    real(8), dimension(Dim):: rij, Posi
    integer :: i, j
    real(8):: d2, id2, id6, id12, id3
    real(8):: r, rc2, shift
    PEnergy = 0.
    shift= -4*(Cut**(-12)-Cut**(-6))- ratio* Cut**(-3)
    rc2=Cut*Cut
    do i = 0, NAtom - 1
        Posi = Pos(i,:)
        do j = i + 1, NAtom - 1
            rij = Pos(j,:) - Posi
            rij=rij-L*dnint(rij/L)
            d2=sum(rij*rij)
            r=sqrt(d2)
            if (d2 > rc2)then
                cycle		     
            end if
            id2 = 1. / d2            
            id6 = id2 * id2 * id2
            id3 = sqrt(id6)   
            id12 = id6 * id6         
            PEnergy = PEnergy + 4. * (id12 - id6)+ ratio*id3 + shift
        enddo
    enddo
end subroutine


subroutine calconeatomenergy(Pos, L, Cut, ratio, PEnergy, Dim, NAtom, MoveAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom, MoveAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, Cut, ratio
    real(8), intent(out) :: PEnergy
    real(8), dimension(Dim):: rij, PosMoveAtom
    integer :: j
    real(8):: d2, id2, id6, id12, id3 
    real(8):: r, rc2, shift
    PEnergy = 0.
    shift= -4*(Cut**(-12)-Cut**(-6)) - ratio*Cut**(-3)
    rc2=Cut*Cut
    PosMoveAtom = Pos(MoveAtom,:)
    do j= 0, NAtom-1
        if (j /= MoveAtom) then
            rij = Pos(j,:) - PosMoveAtom
            rij=rij-L*dnint(rij/L)
            d2=sum(rij*rij)
            r=sqrt(d2)
            if (d2 > rc2) then
                cycle		     
            end if
            id2 = 1. / d2            
            id6 = id2 * id2 * id2   
            id12 = id6 * id6
            id3 = sqrt(id6)         
            PEnergy = PEnergy + 4. * (id12 - id6)+ ratio*id3 + shift                            
        end if
    enddo	
end subroutine


subroutine calcenergyforces(Pos, L, Cut, ratio, PEnergy, Forces, Dim, NAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    real(8), intent(in) :: L, Cut, ratio
    real(8), intent(out) :: PEnergy
    real(8), intent(inout), dimension(0:NAtom-1, 0:Dim-1) :: Forces
!f2py intent(in, out) :: Forces
    real(8), dimension(Dim):: rij, Fij, Posi
    real(8):: d2, id2, id6, id12, id3
    real(8):: r, rc2, shift
    integer :: i, j
    PEnergy = 0.
    Forces=0.
    shift= -4*(Cut**(-12)-Cut**(-6)) - ratio*Cut**(-3)
    rc2=Cut*Cut
    do i = 0, NAtom - 1
        Posi = Pos(i,:)
        do j = i + 1, NAtom - 1
            rij = Pos(j,:) - Posi
            rij=rij-L*dnint(rij/L)
            d2=sum(rij*rij)
            r=sqrt(d2)
            if (d2 > rc2) then
                cycle	   	      
            end if
            id2 = 1. / d2            
            id6 = id2 * id2 * id2   
            id12 = id6 * id6
            id3 = sqrt(id6)         
            PEnergy = PEnergy + 4. * (id12 - id6)+ ratio*id3 + shift
            Fij=rij*((-48.*id12 + 24.*id6-3*ratio*id3)* id2)
            Forces(i,:)=Forces(i,:)+Fij
            Forces(j,:)=Forces(j,:)-Fij            
        enddo
    enddo
end subroutine


subroutine calceatomnumber(Pos, L, Cut2, mm, Dim, NAtom, oneAtom)
    implicit none
    integer, intent(in) :: Dim, NAtom, oneAtom
    real(8), intent(in), dimension(0:NAtom-1, 0:Dim-1) :: Pos
    integer, intent(out) :: mm
    real(8), intent(in) :: L, Cut2
    real(8), dimension(Dim):: rij, PosoneAtom
    integer :: i, j
    real(8):: d2
    real(8):: r, rc2
    rc2=Cut2*Cut2
    PosoneAtom = Pos(oneAtom,:)
    mm=1
    do j = oneAtom + 1, NAtom - 1
        rij = Pos(j,:) - PosoneAtom
        rij=rij-L*dnint(rij/L)
        d2=sum(rij*rij)
        r=sqrt(d2)
        if (d2 <= rc2)then
            mm=mm+1	     
        end if
    enddo
end subroutine

